function task1()

%--------------------------------------------------------------------------
% Basic image processing
%--------------------------------------------------------------------------

% load the image 'lena.png'
% img = TODO lena.png

figure;
subplot(2, 3, 1);
imagesc(img);
axis image;

% select the green channel. Change the data type to 'double' and scale the values of the green channel to a range between 0 and 1.
% imgG = TODO;

% display the green channel as a grayscale image
subplot(2, 3, 2);
%TODO

% (numerically) compute the gradient along x direction using central differences.
%gX = TODO;
% (numerically) compute the gradient along y direction using central differences.
%gY = TODO;
% compute the gradient magnitude
%g = TODO;
% rescale the gradient maps gX, gY to a range [-1;1], and g to a range [0;1] for display

% display gX, gY, g
subplot(2, 3, 4);
%TODO
subplot(2, 3, 5);
%TODO
subplot(2, 3, 6);
%TODO

% write the magnitude map to a PNG file
% TODO 'gradient.png'

%--------------------------------------------------------------------------
% Triangle
%--------------------------------------------------------------------------
dt = pi/200;
t = -2*pi:dt:2*pi-dt;

% evaluate the triangle function
% triangle = TODO;

% n is the number of Fourier coefficients
n = 100;

figure;
subplot(2, 3, 1);
% plot the triangle function
% plot(TODO, TODO, 'k');
title('Triangle Original')
set(gca, 'XTick', [-2*pi;-pi;0;pi;2*pi])
set(gca, 'XTickLabel', {'-2pi';'-pi';'0';'pi';'2pi'})

[triangleA, dmsd, dmad] = approx_triangle(triangle, t, n);

subplot(2, 3, 2);
plot(t, triangle, 'k');
title('Triangle Approximation')
set(gca, 'XTick', [-2*pi;-pi;0;pi;2*pi])
set(gca, 'XTickLabel', {'-2pi';'-pi';'0';'pi';'2pi'})
hold on;
%plot(TODO, TODO, 'r');

% use the subplot to plot the average quadratic difference in red
% and the maximum absolute difference in blue
subplot(2, 3, 3);
% TODO
title('Deviation from Original')

%--------------------------------------------------------------------------
% Saw tooth
%--------------------------------------------------------------------------

% evaluate the saw tooth function
% sawtooth = TODO;

subplot(2, 3, 4);
% plot the saw tooth function
% plot TODO
title('Saw Tooth Original')
set(gca, 'XTick', [-2*pi;-pi;0;pi;2*pi])
set(gca, 'XTickLabel', {'-2pi';'-pi';'0';'pi';'2pi'})

[sawtoothA, smsd, smad] = approx_sawtooth(sawtooth, t, n);

subplot(2, 3, 5);
plot(t, sawtooth, 'k');
title('Saw Tooth Approximation')
set(gca, 'XTick', [-2*pi;-pi;0;pi;2*pi])
set(gca, 'XTickLabel', {'-2pi';'-pi';'0';'pi';'2pi'})
hold on;
plot(t, sawtoothA, 'r');

% use the subplot to plot the average quadratic difference in red
% and the maximum absolute difference in blue

subplot(2, 3, 6);
% TODO

%--------------------------------------------------------------------------
% Calculation of Fourier coefficients
%--------------------------------------------------------------------------
dt = pi/100;
t = -pi:dt:pi-dt;

% Evaluate the function g
% g = TODO;

n = 50;

[an, bn] = compute_coefficients(g, t, n);

% Apply a threshold to the coefficients
% s = 0;
% an(TODO) = TODO;
% bn TODO;

% approximate the function with the first n Fourier coefficients that were just
% computed
approx = approx_function(t, an, bn, n);

figure;
subplot(1, 3, 1);
% plot the function g
% plot TODO
subplot(1, 3, 2);
% plot the coefficients an(0) to an(n) and bn(1) to bn(n)
% TODO
subplot(1, 3, 3);
% plot the function g in black, and its approximation in red
% TODO

end

% ------------------------------------------------------------------------
% Supporting functions
% ------------------------------------------------------------------------

function [fa, msd, mad] = approx_triangle(ft, t, n)

% Initialize a0
% a0 = TODO;

% for all t, initialize fa with a0/2
% fa = TODO;

% rmsd stands for root mean square difference; mad stands for maximum absolute difference
rmsd = [];
mad = [];

% add the computation of the Fourier coefficients according to the analytically
% computed formula, and compute the function approximation for the coefficients
% between 1 and n.
for k = 1:n

    % an = TODO; bn = TODO;
    % fa = TODO;
   
	% add here the computation of the root mean square distance and the maximum
	% absolute distance. Append the results to rmsd and mad, respectively.
    % rmsd = [rmsd, TODO];
    % mad = TODO;

end

end

function [fa, msd, mad] = approx_sawtooth(ft, t, n)

% compute the approximation of the sawtooth function for the first n
% coefficients, analogously to the triangle function.

end

function [an, bn] = compute_coefficients(g, t, n)

an = zeros(1, n+1);
bn = zeros(1, n);

% assume that t covers only a single period of the function
% T = TODO;     % length of the period
% dt = TODO;    % distance between sample points
% w = TODO;     % fundamental frequency

% compute the DC component, i.e., a0, of function g
% an(1) = TODO;

% compute the Fourier coefficients 1 to n using a 'for' loop
% in order to obtain an(k) and bn(k), compute the inner product between the
% function and a sine function or cosine function, respectively.
%TODO

end

function [approx] = approx_function(t, an, bn, n)

% at every position of t, initialize the approximation with a0/2
% approx = TODO;

% compute the length of the period and the fundamental frequency
% T = TODO;
% w = TODO;

% approximate the function with the first n coefficients with a 'for' loop.
%TODO

end
